-- author: rafftnix
-- date: 30.06.2015

-- note: rafftnixGUI needed!!

WorkCamera = {};

function WorkCamera.prerequisitesPresent(specializations)
    return RafftnixGUI ~= nil and RafftnixGUI.version >= 1.52;
end;

function WorkCamera.registerEventListeners(vehicleType)	
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", WorkCamera);
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", WorkCamera);
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", WorkCamera);
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", WorkCamera);
end;

function WorkCamera:onLoad(savegame)
	self.setWorkCamPos = SpecializationUtil.callSpecializationsFunction("setWorkCamPos");

	self.workCamera = RafftnixGUI:new(nil, false, false);

	if hasXMLProperty(self.xmlFile, "vehicle.workCamera.backGround") then
		local posX = getXMLFloat(self.xmlFile, "vehicle.workCamera.backGround#x");
		local posY = getXMLFloat(self.xmlFile, "vehicle.workCamera.backGround#y");
		local width = getXMLFloat(self.xmlFile, "vehicle.workCamera.backGround#width");
		local height = getXMLFloat(self.xmlFile, "vehicle.workCamera.backGround#height");
		local fileName = getXMLString(self.xmlFile, "vehicle.workCamera.backGround#fileName");
		self.workCameraBG = self.workCamera:createImage(self.workCamera.baseElement, posX, posY, width, height, fileName);
	end;
	
	local cameraId = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.workCamera#index"));
	local posX = getXMLFloat(self.xmlFile, "vehicle.workCamera.position#x");
	local posY = getXMLFloat(self.xmlFile, "vehicle.workCamera.position#y");
	local width = getXMLFloat(self.xmlFile, "vehicle.workCamera.position#width");
	local height = getXMLFloat(self.xmlFile, "vehicle.workCamera.position#height");
	self.workCameraOverlay = self.workCamera:createRenderOverlay(self.workCamera.baseElement, posX, posY, width, height, cameraId, getScreenAspectRatio());
end;

function WorkCamera:onDelete()
	self.workCamera:onDelete();
end;

function WorkCamera:mouseEvent(posX, posY, isDown, isUp, button)
end;

function WorkCamera:keyEvent(unicode, sym, modifier, isDown)
end;

function WorkCamera:onUpdate(dt)
	if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.WORKCAMERA) then
			local visibility = self.workCamera.baseElement.visibility;
			visibility = not visibility;
			if visibility then
				self.workCamera:open();
			else
				self.workCamera:close();
			end;
		end;
	elseif self.workCamera.baseElement.visibility then
		self.workCamera:close();
	end;
end;

function WorkCamera:onDraw()
	if self.workCamera.baseElement.visibility then
		g_currentMission:addHelpButtonText(g_i18n:getText("deactivateWorkCamera"), InputBinding.WORKCAMERA); 
	else
		g_currentMission:addHelpButtonText(g_i18n:getText("activateWorkCamera"), InputBinding.WORKCAMERA); 
	end;
end;

function WorkCamera:setWorkCamPos(posX, posY, width, height, bgX, bgY, bgWidth, bgHeight)
	self.workCameraOverlay:setPosition(posX, posY);
	self.workCameraOverlay:setDimension(width, height);

	if self.workCameraBG ~= nil then
		self.workCameraBG:setPosition(bgX, bgY);
		self.workCameraBG:setDimension(bgWidth, bgHeight);
	end;
end;